Attribute VB_Name = "Global"
Option Explicit

'
' mapiform variables needed for form management
'
Public Children As New Collection
Public ChildIndex As Integer
'
' messages used for replies, etc.
'
Public msgSource As Object
Public msgDestClass As String
Public gCurrentVerb As Integer
Public MasterFrm As Form
Public fInDialog As Boolean
Public fQHelpLoaded As Boolean
'
' unsubmitted and submitted form constants
'
Global Const US_FORM = 1
Global Const S_FORM = 2

'
' for saving
'
Global fSave As Integer
Global Const SAVE_MSG = 0
Global Const SAVE_ATTACH = 1
Global Const SAVE_TXT = 2

'
' for prev/next
'
Global Const ACTIVATE_NEXT = True
Global Const ACTIVATE_PREVIOUS = False

'
' for tasklist
'
Global Const ADD_TASK = True
Global Const REMOVE_TASK = False
Private fAlwaysInTaskList As Boolean
Private fTaskHidden As Boolean

'
' verbs
'
' Exchange events that can be passed to a form,
' and events that can occur from the form's menus.
'
Global Const VERB_OPEN = 0
Global Const VERB_PRINT = 105
Global Const VERB_SAVEAS = 106
Global Const VERB_REPLY = 102
Global Const VERB_REPLYALL = 103
Global Const VERB_REPLYTOFOLDER = 108
Global Const VERB_FORWARD = 104
Global Const VERB_CUSTOM1 = 9
Global Const VERB_CUSTOM2 = 10
Global Const VERB_CUSTOM3 = 11
Global Const VERB_CUSTOM4 = 12
Global Const VERB_CUSTOM5 = 13
Global Const VERB_SAVECOMMIT = 14
Global Const VERB_SAVE = 15
Global Const VERB_SAVECOMMIT_VALIDATE = 16
Global Const VERB_SAVE_VALIDATE = 17
'
' for MAPI properties
'
Global Const MAPI_PROP_GUID_STRING = "{00020329-0000-0000-C000-000000000046}"
Global Const Created_Prop = "MS_EXCHANGE_01"
'
' special flag used in conjuction will variant array type to indicate
' MAPI data must me streamed into a file
'

Global Const vbBlobFlag = &H1F1F
Global Const vbBlob = 65

Global Const MAPI_PR_BODY = &H1000
Global Const MAPI_PR_ACCESS_LEVEL = &HFF70003
Global Const MAPI_PR_MESSAGE_FLAGS = &H36631

'
' there are more rights than this
' but this is the only one codegen supports
'

Global Const MAPI_PR_RIGHTS_NoEdit = &H0
'
' Exchange Error Codes
'
Global Const E_Verb_Err = &H80000003
Global Const E_NoMem_Err = &H80000008 
Global Const E_Fail_Err = &H80004005

Global Const MAPI_FROM = 0
Global Const MAPI_TO = 1
Global Const MAPI_CC = 2
Global Const MAPI_BCC = 3

'
' Reply style constants
'
Global Const REPLY_SIMPLE = 0
Global Const REPLY_ALL = 1
Global Const REPLY_FOLDER = 2

'
' Return codes for file APIs
'
Global Const RCNO_TEMP_PATH = 0
Global Const RCNO_TEMP_FNAME = 0

'
' Help Types for Menus
'
Global Const HT_QUICK = 0
Global Const HT_USERWIN = 1
Global Const HT_EXCHANGE = 2
Global Const HT_NONE = 3

Public Const MENU_ITEMS_MAX = 75

' Resource types
Public Const ResType = &H100
Public Const ResType_TT = 0 'Tool tip
Public Const ResType_QH = 1 'Quick Help
Public Const ResType_QC = 2 'Quick Help window caption
Public Const ResType_ST = 3 'Status bar message
Public Const ResType_IN = 4 'Initial contents
Public Const ResType_ENV = 5 'Envelope field recipient list
Public Const ResType_TAB = 6 'Tab page panel resides on
Public Const ResMenuBase = &H7800
                                      
'
' priorities
'
Public Const PRIO_HIGH = 2
Public Const PRIO_NORMAL = 1
Public Const PRIO_LOW = 0

'
' commdlg settings
'
Global Const ComDlgFlags = &H1804

Public fSettingProps As Boolean 'prevent recursion


'
' Definitions & APIs for getting a unique GUID
'

Type GUID
    Guid1 As Long
    Guid2 As Long
    Guid3 As Long
    Guid4 As Long
End Type

Type FILETIME
    lLowDate As Long
    lHighDate As Long
End Type

Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

    
Global Const NOTCREATINGNEW = False 'not handling "Create_New/Compose_New" case
Global Const STRTABCLASS = "MSTabCtl"

Declare Function CoCreateGuid Lib "COMPOBJ.DLL" (pGuid As GUID) As Long
Declare Function GetSystemTime Lib "mapi.DLL" (pSysTime As SYSTEMTIME) As Long
Declare Function SystemTimeToFileTime Lib "mapi.DLL" (pSysTime As SYSTEMTIME, pFileTime As FILETIME) As Long

'Declare Function CoFileTimeNow Lib "COMPOBJ.DLL" (pFileTime As FILETIME) As Long

Global Const S_OK = 0

'
' these should be in winapis
'
Declare Function GetTempFileName Lib "Kernel" (ByVal cDrvLetter As Integer, ByVal stPrefix As String, ByVal wUnique As Integer, ByVal stTmpFName As String) As Integer
Global Const NEW_FNAME = 0
Declare Function GetTempDrive Lib "Kernel" (ByVal cDrvLetter As Integer) As Integer

Global Const CI_INISEP = ","                    ' win.ini device line separator

Sub Main()
    '
    ' Put up wait cursor
    '
    Screen.MousePointer = HOURGLASS
    '
    ' init the child window count
    '
    ChildIndex = 0
    
    '
    ' init the Dialog flag
    '
    
    fInDialog = False
    '
    ' init the special error strings
    '
    
    InitString4Error 
    
    '
    ' load the form containing the mapiform vbx
    '
    
    Load frmAdmin

    OSVerInfo.OSVersionInfoSize = Len(OSVerInfo)
    Call VBGetVersionEx32(OSVerInfo)
    
End Sub

Public Sub CreateWindow(mf As Object, frm As Form, cw As ChildWindow)
    '
    ' if no child window assigned
    '
    If mf.OwnerChildWindow = 0 Then
        '
        ' increment the child counter
        '
        ChildIndex = ChildIndex + 1
        '
        ' create the childwindow object
        '
        Set cw = New ChildWindow

        Set cw.frm = frm
        Children.Add cw, str$(ChildIndex)
        '
        ' register the child window with the mapiform object
        '
        mf.OwnerChildWindow = ChildIndex
        '
        ' Set child local var to point to parent
        '
        Set frm.mfobj = mf
    Else
        '
        ' the window is already open
        '
        Set cw = Children.Item(str$(mf.OwnerChildWindow))
        Set frm = cw.frm
    End If
End Sub



Function StripVal(inText As String) As Variant
    Dim oText As String
    Dim tText As String
    Dim dPoint As String
    Dim stLen As Integer
    Dim count As Integer
    Dim sample As Single
    Dim hasNum As Boolean
    Dim lastExponent As Boolean
    hasNum = False
    
    sample = 1
    oText = Format$(sample,"#.##")
    
    dPoint = Mid(oText, 2, 1) 'gets the decimal point

    stLen = Len(inText)
    For count = 1 To stLen
        
        oText = Mid(inText, count, 1)
        
        Select Case oText
            
            Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"
                tText = tText + oText
                hasNum = True
                
            Case "-" ' keep leading and trailing '-'s
                If (count = 1) Or lastExponent Then
                    tText = tText + "-"
                ElseIf (count = stLen) Then
                    tText = "-" + tText ' make it a leading -
                Else
                    tText = tText + " " ' strip it
                End If
            Case "E","e" ' exponent
                tText = tText + "E"
                lastExponent = True
            Case "(" ' keep () indicating negative
                tText = tText + "-"
            Case dPoint
                tText = tText + "." ' decimal place
            Case Else
                tText = tText + " " ' replace with space
        End Select
    Next count
    
    If hasNum Then StripVal = Val(tText) ' get the value from the stripped string
    
End Function

Function ValidateStr(ByVal inputStr As String, fmtStr As String, vType As Integer) As Variant
    On Error GoTo Badentry
    Dim answer As Variant
    Dim szTemp As String
    
    ValidateStr = Null
    
    Select Case vType
    
    Case vbstring
        If inputStr Like fmtStr Then
            ValidateStr = inputStr
        End If
        Exit Function
    Case vbInteger, vbLong, vbSingle, vbDouble, vbCurrency
        answer = StripVal(inputStr)
        ' thang = CVar(entry(index))

        If IsNumeric(answer) And Len(answer) <> 0 Then
        
            If vType = vbLong Then answer = CLng(answer) ' check for overflow
            
            If vType = vbCurrency Then answer = CCur(answer) ' check for overflow
            '
            ' make sure the format string is okay
            '
            szTemp = Format(answer, fmtStr ) ' may generate a runtime error
            
            ValidateStr = answer
        End If
        Exit Function
            
    Case vbDate
        '
        'if this is a NN:SS format date (time)
        '
        If InStr(1, fmtStr, "NN", 1) = 1 Then
            '
            ' massage the input date so it looks more like a standard time
            '
            answer = ValidateStr("12:" & inputStr, "HH:" & fmtStr, vType)
            ValidateStr = answer
        Else
            Dim strChop As String
            
            strChop = inputStr
            
            On Error Resume Next

            answer = CDate(strChop)
            
            Do While Not (IsDate(answer)) And (Len(strChop) <> 0)
                strChop = Mid(strChop, 2)
                answer = CDate(strChop)
            Loop
            
            If IsDate(answer) Then
                ValidateStr = answer
                On Error Goto Badentry
                '
                ' make sure the format string is okay
                '
                
                szTemp = Format(answer, fmtStr ) ' may generate a runtime error
            End If

        End If
        
        Exit Function
        
   End Select
   Exit Function
   
Badentry:
    ValidateStr = Null
    Exit Function

 Resume Next

End Function
Function VstCreateTempFName() As String
'
' Returns a temporary file name in the temporary path.
'
    Dim rc As Integer                   ' return code
    Dim stDrvPath As String             ' path to temporary drive
    Dim stTempFName As String * 256     ' string for temporary file name
    Dim cDrvLetter As Integer           ' drive letter as integer
    Static iTempFName As Integer

    On Error GoTo VstCreateTempFNameErr

    VstCreateTempFName = ""
    '
    ' Get the temporary directory path.
    '
    rc = GetTempDrive(cDrvLetter)
    If rc > RCNO_TEMP_PATH Then
        '
        ' Find a unique temporary file name and create and close the new file.
        '
        iTempFName = iTempFName + 1
        rc = GetTempFileName(Asc(Chr$(rc And &HFF)), "prp", iTempFName, stTempFName)
        
        If rc <> RCNO_TEMP_FNAME Then
            '
            ' This indicates success.
            '
            VstCreateTempFName = Trim$(Left$(stTempFName, InStr(stTempFName, Chr$(0)) - 1))
            '
            'clean out unwanted chars
            '
            
        End If
    End If

    Exit Function

VstCreateTempFNameErr:
    If Err > 0 Then
    
        frmAdmin.MapifVbx1.NoEvents = True
        
        MsgBox (TEMPFCREATEERR & "[" & CStr(Err) & "]")
        
        frmAdmin.MapifVbx1.NoEvents = False
        
    End If
    
End Function


Public Sub SetMapiProp(ByVal fldValue As Variant, Prop As Variant, vType As Integer, Msg As Object)
    On Error GoTo SetError
    
    Dim fieldVal As Variant
    Dim fieldObj As Object
    Dim strPropname As String
    Dim lwPropID As Long
    Dim objF As Object

    Set fieldObj = Msg.Fields
    
    
    If VarType(Prop) = vbstring Then
    
        strPropname = CStr(Prop)
        
        If IsNull(fldValue) Then fldValue = "" ' make field value convertable
        
        Select Case strPropname
        '
        ' set special mapi properties
        '
        Case "MAPI_Body_Custom"
            Msg.Text = CStr(fldValue)
        Case "MAPI_Subject_Custom"
            Msg.Subject = CStr(fldValue)
        Case "MAPI_Topic_Custom"
            Msg.ConversationTopic = CStr(fldValue)
        Case Else
            '
            ' non-mundane named mapi property
            '
            If vType >= vbArray Then
                '
                ' Check arrays first to prevent type mismatching
                '
                
                Select Case vType
                Case vbArray, vbArray + vbstring
                    '
                    ' this is an array of strings
                    '
                    
                    If (VarType(fldValue) And vbArray) <> vbArray Then fldValue = Array(fldValue)

                    If fldValue(0) <> "" Then 
                        Set objF = fieldObj.Add(strPropname, (vbArray + vbstring)) ' add the field (no value)
                        '
                        ' assign the array (MDISP requires arrays to be added this way)
                        '
                        objF.Value = fldValue 
                    Else
                        '
                        ' No value, delete the property
                        '
                        fieldObj(strPropName).Delete
                    End If
                     
                    GoTo ExitPoint
                Case vbArray + vbVariant
                    '
                    ' since we only store strings in multi val props
                    ' this is the stream to file special case
                    '
                    Set objF = fieldObj.Add(strPropname, vbBlob)
                    '
                    ' add the field (no value supplied)
                    '
                    objF.ReadFromFile (fldValue(1))
                    '
                    ' delete temp file
                    '
                    Kill CStr(fldValue(1))
                    
                    GoTo ExitPoint
               End Select
                    
            '
            ' check for empty property
            '
            ElseIf (fldValue & "") = "" Then 'if no value
                Dim delField As Object
                '
                ' delete the old field
                '
                Set delField = fieldObj.Item(strPropname)
                
                delField.DELETE
                
                Set delField = Nothing
           
            Else
                Select Case vType
                
                '
                ' specifically cast the save value to the correct type
                '
                
                Case vbLong
                    fieldVal = CLng(fldValue)
                Case vbstring
                    fieldVal = CStr(fldValue)
                Case vbCurrency
                    fieldVal = CCur(fldValue)
                Case vbDouble
                    fieldVal = CDbl(fldValue)
                Case vbDate
                    fieldVal = CDate(fldValue)
                Case Else
                    fieldVal = fldValue
                        
                End Select ' vtype
                
                '
                ' always do an add, it will overwrite existing properties
                '
                
                fieldObj.Add strPropname, vType, fieldVal
            End If
        End Select 'strPropname
    Else ' strPropName is a Special MAPI Prop
        lwPropID = CLng(Prop) ' get numeric property ID
        
        fieldObj.Add lwPropID, vbBlob
        '
        ' add the field (no value supplied)
        '
        fieldObj(lwPropID).ReadFromFile (CStr(fieldVal))
        '
        ' field Val is the path to the tmp file
        '
        Kill CStr(fieldVal)
        '
        ' we are finished copying the data over so we delete the temp file
        '
    End If

SetError:
ExitPoint:
    Set fieldObj = Nothing

    Exit Sub
End Sub

Public Function GetMapiProp(Prop As Variant, Msg As Object,fGetBinary as Boolean) As Variant
    On Error GoTo GetError
    Dim RetVal As Variant
    Dim fieldObj As Object
    Dim strPropname As String
    
    Set fieldObj = Msg.Fields
    
    If VarType(Prop) = vbstring Then
    '
    ' If it's a Named Mapi property
    '
        strPropname = CStr(Prop)
        Select Case strPropname
            '
            ' get special mapi properties
            '
            Case "MAPI_Body_Custom"
                RetVal = Msg.Text
            Case "MAPI_Subject_Custom"
                RetVal = Msg.Subject
            Case "MAPI_SentDate_Custom"
                RetVal = Msg.TimeSent
            Case "MAPI_From_Custom"
                RetVal = Msg.Sender.Name
            Case "MAPI_Topic_Custom"
                RetVal = Msg.ConversationTopic
            Case "MAPI_Index_Custom"
                RetVal = Msg.ConversationIndex
            Case Else
            
                '
                ' get mundane mapi property and return it's value
                '
                If fieldObj(strPropname).Type = vbBlob Then
                    '
                    ' check to see if we're getting Binary Props
                    '
                    if Not fGetBinary Then
                        RetVal = Null
                    else
                        '
                        ' Create a temp file to store the property in
                        ' and store it in a mixed array as a special flag
                        ' to indicate it must me streamed
                        '
                        
                        
                        RetVal = Array(vbBlobFlag, VstCreateTempFName)
                        
                        '
                        ' write the property to the temp file
                        '
                        fieldObj(strPropname).WriteToFile (RetVal(1))
                        '
                        ' return the name of the temp file written to
                        '
                    end if
                Else
                    '
                    ' otherwise just get the field value
                    '
                    RetVal = fieldObj(strPropname).Value
                End If
                
             End Select
        
        GetMapiProp = RetVal
        
    Else
        '
        ' get numbered property
        '
        
       RetVal = fieldObj(CLng(Prop)).Value

    End If
    Set fieldObj = Nothing
    '
    ' release referrence
    '
    
    GoTo ExitPoint
GetError:
    Set fieldObj = Nothing
    
    GetMapiProp = Null

ExitPoint:

End Function

Public Function Copy_Reply(curUserIDStr as String, msgIn As Object, msgOut As Object, repType As Boolean) As Boolean
    Dim count As Integer
    Dim maxCount As Integer
    Dim Addresses As Object
    Dim address As Object
    Dim addrIDStr As Variant
    Dim addressStr As Variant
    Copy_Reply = True



    If InStr(1, msgIn.Subject, REPLY_STRING, 0) = 1 Then
    '
    ' if it's already an 'RE:...' subject
    '
        msgOut.Subject = msgIn.Subject
        '
        ' just copy the subject
        '
    Else
        msgOut.Subject = REPLY_STRING & msgIn.Subject
        '
        ' else pre-pend 'RE:'
        '
    End If

    If repType = REPLY_FOLDER Then
        Exit Function
    End If

    '
    'resume next because there might not be a sender...
    '

    On Error Resume Next

    Set Addresses = msgOut.Recipients

    '
    ' get the sender
    '
    With msgIn.Sender

        '
        ' add the sender to the to list
        '
        addrIDStr = .Id
        addressStr = .address
        Addresses.Add .Name, addressStr, MAPI_TO, addrIDStr 
    End With
    '
    ' release ref
    '
    
    
    On Error GoTo RepError

    If repType <> REPLY_SIMPLE Then

        '
        ' Now we go through all the 'in' addresses and copy them over to the 'out' message
        '

        With msgIn.Recipients

            maxCount = .count
            '
            ' loop through all the in addresses
            '
            For count = 1 To maxCount
                Set address = .Item(count)
                '
                ' copy each one to the new message
                ' we copy the class over so that cc list is maintained
                ' and we ignore BCC addresses
                ' 
                addrIDStr = address.AddressEntry.Id
                
                If curUserIDStr <> addrIDStr And address.Type <> MAPI_BCC Then
                    Addresses.Add address.Name, address.address, address.Type, addrIDStr 
                End If
                '
                ' release ref
                '
                 Set address = Nothing

            Next count

        End With

        '
        ' release ref
        '

    End If

    Set Addresses = Nothing

    Exit Function
RepError:
        Copy_Reply = False
        Set Addresses = Nothing
End Function

Public Function Copy_FW(msgIn As Object, msgOut As Object) As Boolean
On Error GoTo FWError
    Copy_FW = True
    
    If InStr(1, msgIn.Subject, FORWARD_STRING, 0) = 1 Then
    '
    ' if it's already an 'FW:...' subject
    '
        msgOut.Subject = msgIn.Subject
        '
        ' just copy the subject
        '
    Else
        msgOut.Subject = FORWARD_STRING & msgIn.Subject
        '
        ' else pre-pend 'FW:'
        '
    End If
    '
    ' update the message
    '
    msgOut.Update False ' false because we don't want to save the message
    
    Exit Function
FWError:
    Copy_FW = False
    
End Function
Public Function MessageLocked(Msg As Object) As Boolean
Dim folderObj As Object
Dim permission As Long

On Error GoTo FPError
    MessageLocked = False
    '
    ' if there's an error we'll err on the side of freedom !
    '
      
    permission = Msg.Fields.Item(CLng(MAPI_PR_ACCESS_LEVEL)).Value

    If permission = MAPI_PR_RIGHTS_NoEdit Then
        MessageLocked = True
    End If
     
    Set folderObj = Nothing
FPError:
        
End Function
Public Function Copy_Attach(msgIn As Object, msgOut As Object) As Boolean
Dim a As Integer
Dim max As Integer
Dim tempFile As String
Dim newAttach As Object

On Error GoTo AttchError
    Copy_Attach = True
    With msgIn.Attachments
        max = .count
        
        For a = 1 To max
                
            newAttach = msgOut.Attachments.Add(.Item(a).Name, .Item(a).Position, .Item(a).Class, .Item(a).source)
            '
            ' if it's not a file link (ref to a file)
            '
            If Not .Item(a).Class = 1 Then ' file link class = 1
            
                tempFile = VstCreateTempFName
                .Item(a).WriteToFile (tempFile)
                '
                ' copy the data via a temp file
                '
                
                newAttach.ReadFromFile (tempFile)
                Kill tempFile
                
            End If
            '
            ' remove the ref to the object
            '
            Set newAttach = Nothing
        
        Next a
    End With
    Exit Function
AttchError:
    Copy_Attach = False
    
End Function
Public Sub SetListBoxValue(ByVal var As Variant, ctl As Control, inType As Integer)
    Dim Index As Integer
    Dim lstMost As Integer
    Dim strCmp As String
    Dim intComp As Integer
    Static fRecurse As Boolean
    If fRecurse Then Exit Sub
    fRecurse = True
    
    If IsNull(var) Then
        ctl.ListIndex = -1
        fRecurse = False
        Exit Sub
    End If
    
    lstMost = ctl.ListCount - 1
    
   
    Select Case inType
        Case vbLong
            '
            ' if this list is numerically optimized
            '
            intComp = CLng(var) ' convert variant to faster integer type
            
            For Index = 0 To lstMost
                '
                ' compare each entry in the list/combo box
                '
                If ctl.itemData(Index) = intComp Then
                    '
                    ' until you find a matching itemData
                    '
                    ctl.ListIndex = Index
                    fRecurse = False
                    Exit Sub
                End If
            Next Index
            ' no matches
            ctl.ListIndex = -1
        Case vbstring
            '
            ' if this list is NOT numerically optimized
            '
            strCmp = CStr(var) ' convert variant to slightly faster string
            
            For Index = 0 To lstMost
                '
                ' compare each entry in the list/combo box
                '
                If ctl.List(Index) = strCmp Then
                    ctl.ListIndex = Index
                    '
                    ' until you find a matching string
                    '
                    fRecurse = False
                    Exit Sub
                    
                End If
            Next Index
            ' no matches. clear the contents
            
            ctl.ListIndex = -1
        Case vbArray
            Dim maxArray As Integer
            Dim cArray As Integer
            Dim fCount As Integer
            
            If Not IsArray(var) Then var = Array(var)
            
            maxArray = UBound(var)
            
            fCount = maxArray + 1
            
            ' strComp = CStr(var) ' convert variant to slightly faster string
            
            For Index = 0 To lstMost
                '
                ' compare each entry in the list/combo box
                '
                If fCount <> 0 Then
                    For cArray = 0 To maxArray
                        If var(cArray) <> "" Then
                            If ctl.List(Index) = CStr(var(cArray)) Then
                                ctl.Selected(Index) = True
                                
                                '
                                ' until you find a matching string
                                '
                                
                                var(cArray) = "" ' this can no longer be matched
                                fCount = fCount - 1
                                Exit For
                            End If
                        End If
                        ctl.Selected(Index) = False ' no matches
                    Next cArray
                Else
                    ctl.Selected(Index) = False ' no matches left
                End If
            Next Index
        
    End Select
    fRecurse = False
End Sub
Function NewConversationIndex() As String
    'Exchange conversation is a unique 8-byte value
    
    Dim lResult As Long
    Dim lGuid As GUID
    Dim lTime As FILETIME
    Dim sTime As SYSTEMTIME
    Dim sTimeData
    Dim a As Integer
    
    Call GetSystemTime(sTime)

    lResult = SystemTimeToFileTime(sTime, lTime)
    lResult = CoCreateGuid(lGuid)
    If lResult = S_OK Then
        sTimeData = LongToHex(lTime.lHighDate) & LongToHex(lTime.lLowDate)
        sTimeData = Mid(sTimeData, 3, 10) ' cut off upper byte and lower 2 bytes
        NewConversationIndex = Hex$(0) & Hex$(1) & sTimeData & LongToHex(lGuid.Guid1) & LongToHex(lGuid.Guid2) & LongToHex(lGuid.Guid3) & LongToHex(lGuid.Guid4)
    End If
End Function
Function AddConversationIndex(CurrentIndex As String) As String
    'Exchange conversation is a unique 8-byte value
    
    Dim lResult As Long
    Dim lTime As FILETIME
    Dim sTimeStr As String
    Dim sDTimeStr As String
    Dim sThread As String
    
    Dim firstTime As Currency
    Dim totalTime As Currency
    Dim TimeAsCurrency As Currency
    Dim TempCurr As Currency
    Dim lToCurr As Currency
    Dim Cur32Bits As Currency
    Dim Cur23Bits As Currency
    Dim Cur18Bits As Currency
    Dim indxCount As Integer
    Dim sTime As SYSTEMTIME
    Dim dlTime As Long

    indxCount = 0
    
    lToCurr = 0.0001
    
    Cur32Bits = CCur(2 ^ 30) * 4
    
    Cur23Bits = CCur(2 ^ 23)
    
    Cur18Bits = CCur(2 ^ 18)
    
    sTimeStr = Mid(CurrentIndex, 3, 10) ' get the initial time
    
    firstTime = CCur(HexToLong(Left$(sTimeStr, 6)))
    
    firstTime = (firstTime * lToCurr) * (256 ^ 2)
    
    firstTime = firstTime + (CCur(HexToLong(right$(sTimeStr, 4))) * lToCurr)

    firstTime = firstTime * (256 ^ 2)
    
    '
    ' get the delta time threads
    '
    sTimeStr = right$(CurrentIndex, Len(CurrentIndex) - 44)
    totalTime = 0
    
    If Len(sTimeStr) >= 10 Then
        '
        ' loop throught all of the 5 byte index threads
        '
        
        Do While Len(sTimeStr) > 0
            sDTimeStr = Left(sTimeStr, 8) ' get the delta time
            '
            ' The uppermost bit is used to determine the units
            ' of time, not the sign of the number
            '

                TempCurr = CCur(HexToLong("0" & Left(sTimeStr, 2))) * lToCurr
                
                TempCurr = (TempCurr * 256) + (CCur("0" & HexToLong(Mid(sTimeStr, 3, 2))) * lToCurr)

                TempCurr = (TempCurr * 256) + (CCur("0" & HexToLong(Mid(sTimeStr, 5, 2))) * lToCurr)
                
                TempCurr = (TempCurr * 256) + (CCur("0" & HexToLong(Mid(sTimeStr, 7, 2))) * lToCurr)
                
            dlTime = HexToLong(sDTimeStr)
            
            If dlTime > 0 Then
                
                totalTime = totalTime + (TempCurr * Cur18Bits)
               
            Else
                If dlTime < -&H10000 Then  ' FIX for backwards time bug (Remove for final)
                    totalTime = totalTime + (TempCurr * Cur23Bits)
                End If
            End If
            
            sTimeStr = Mid$(sTimeStr, 11)
            
        Loop
        indxCount = HexToLong(right(CurrentIndex, 1)) ' get the last index count
        indxCount = indxCount + 1
    End If
    '
    ' now calculate the delta time
    '
    lResult = GetSystemTime(sTime)

    lResult = SystemTimeToFileTime(sTime, lTime)
    
    'lResult = CoFileTimeNow(lTime)

    TimeAsCurrency = ((CCur(lTime.lHighDate And &HFFFFFF) * lToCurr) * Cur32Bits)
    
    If lTime.lLowDate < 0 Then
        TempCurr = (CCur(lTime.lLowDate And &H7FFF0000) * lToCurr) + CCur(&H7FFFFFFF * lToCurr) ' 2s complement
    Else
        TempCurr = (CCur(lTime.lLowDate And &HFFFF0000) * lToCurr)
    End If
    
    TimeAsCurrency = TimeAsCurrency + TempCurr

    TimeAsCurrency = TimeAsCurrency - firstTime
    
     
    totalTime = TimeAsCurrency - totalTime
    
    '
    ' check for final answer 31 bit overflow
    '
    
    If totalTime < 0 Then ' don't allow delta times < 0
        totalTime = Cur18Bits / 10000
    End If

    On Error GoTo OVERFlow
    
    If CCur(totalTime / Cur18Bits) > CCur(&H7FFFFFFF * lToCurr) Then
        totalTime = totalTime / Cur23Bits
        dlTime = CLng(totalTime * 10000)
    Else
        totalTime = totalTime / Cur18Bits
        dlTime = CLng(totalTime * 10000)
    End If
    
    sThread = LongToHex(dlTime) & Hex(Int(Rnd * 16)) & Hex(indxCount Mod 16)
    
    AddConversationIndex = CurrentIndex & sThread
    
    Exit Function

OVERFlow:
    dlTime = &HFFFFFFFF ' max possible delta time
    Resume Next
    
End Function



Public Function LongToHex(lLong As Long) As String
    ' converts long to 8-digit hex string, left-padded as needed
    Dim Temp As String
    
    Temp = Hex$(lLong)
    LongToHex = Left$("00000000", 8 - Len(Temp)) & Temp
End Function
Public Function HexToLong(sHex As String) As Long
    ' converts 8-digit hex string to long
    
    HexToLong = CLng("&H" & sHex)
    
End Function


Public Sub Update_Tasklist(fAdd As Boolean, frmCurr As Form)
    ' adds or removes application from windows tasklist
    Dim frm
    Dim fLoaded As Boolean
    
    If Not fAlwaysInTaskList Then
        If fAdd Then
            ' add to tasklist
            Call HideOwner(False)
        Else
            ' remove from tasklist
            If Not fTaskHidden Then
                If Children.count = 0 Then ' no forms open
                    Call HideOwner(True)
                End If
            End If
        End If
    End If
End Sub

Public Sub HideOwner(fHide As Boolean)
    ' hides or shows owner window of app
    Static hWndOwner As Integer
    Dim ret As Integer
    If Not fAlwaysInTaskList Then
        If fTaskHidden <> fHide Then
            If hWndOwner = 0 Then
                hWndOwner = GetWindow(frmAdmin.hWnd, GW_OWNER)
            End If
    
            ret = ShowWindow(hWndOwner, IIf(fHide, SW_HIDE, SW_SHOW))
    
            fTaskHidden = fHide
        End If
    End If
End Sub


Sub Get_SysVer()
    ' read efd.ini and set global variables
    Dim verWind As Long
    
    verWind = GetVersion() And &HFF
    
    If verWind >= VER_WIN95 Then
        ' Always show in the tasklist
        fAlwaysInTaskList = True
    Else
        ' Show in tasklist when form is visible
        fAlwaysInTaskList = False
        
        Call HideOwner(True)
    End If

End Sub




Public Function GetListBoxVal(ctl As ListBox) As Variant
    Dim lstMost As Integer
    Dim IndexList As Integer
    Dim IndexArr  As Integer
    Dim answer() As String
    
    IndexArr = 0
    lstMost = ctl.ListCount - 1
    
    For IndexList = 0 To lstMost
        '
        ' check each entry in the list box
        '
        If ctl.Selected(IndexList) Then

            ReDim Preserve answer(IndexArr)
            answer(IndexArr) = ctl.List(IndexList)
            IndexArr = IndexArr + 1
            
        End If
    Next IndexList
    
    If IndexArr = 0 Then
        GetListBoxVal = Null
    Else
        GetListBoxVal = answer
    End If
    
    
End Function
