Attribute VB_Name = "Toolbar"
Option Explicit
'
' for either toolbar
'
Global Const TB_HEIGHTEXTRA = 6          ' pixels
Global Const TB_XSTART = 8               ' pixels
Global Const TB_GAPWIDTH = 7             ' pixels
Global Const TB_YSTART = 3               ' pixels

'
' for unsubmitted ToolBar
'
Global Const US_TBCOUNT = 12
Global Const US_TBGAPCOUNT = 4
Global Const US_TBGAP0 = 2
Global Const US_TBGAP1 = 5
Global Const US_TBGAP2 = 8
Global Const US_TBGAP3 = 9

Global Const US_TB_BMPOFFSET = 1

Global Const US_BIGSENDOFFSET = 40
Global Const US_BIGPOSTOFFSET = 42

Global Const US_TBSEND = 0
Global Const US_TBSAVE = 1
Global Const US_TBPRINT = 2
Global Const US_TBCUT = 3
Global Const US_TBCOPY = 4
Global Const US_TBPASTE = 5
Global Const US_TBVERNAMES = 6
Global Const US_TBCHNAMES = 7
Global Const US_TBINSERT = 8
Global Const US_TBRECEIPT = 9
Global Const US_TBPRIOHIGH = 10
Global Const US_TBPRIOLOW = 11

'
' for submitted ToolBar
'
Global Const S_TBCOUNT = 7
Global Const S_TBGAPCOUNT = 2
Global Const S_TBGAP0 = 1
Global Const S_TBGAP1 = 4

Global Const S_TB_BMPOFFSET = 32

Global Const S_TBPRINT = 0
Global Const S_TBDELETE = 1
Global Const S_TBREPLY = 2
Global Const S_TBREPLYALL = 3
Global Const S_TBFORWARD = 4
Global Const S_TBPREVIOUS = 5
Global Const S_TBNEXT = 6

'
' for tooltips
'
Global Const tmsMin = 1
Global Const tmsONESEC = 1000
Global Const SW_SHOWNA = 8

'
' variables
'
Global fTT As Integer                   ' flag for whether tooltips are on
Global gTTCallingForm As Form           ' the form that started tooltips
Global vtppY As Integer
Global vtppX As Integer
Global gTTControl As Control            ' the control to show tooltips for

Sub InitTB(frm As Form)
'
' this routine initializes the toolbar to handle any resolution
'

Dim iTB As Integer
Dim cTB As Integer
Dim xPos As Integer
Dim iGaps As Integer
Dim cGaps As Integer
Dim iBmpOffset As Integer

    If frm.fSubmitted Then
        '
        ' init the submitted toolbar messages and tips
        '
        cGaps = S_TBGAPCOUNT
        ReDim ButtonGaps(cGaps) As Integer
        ButtonGaps(0) = S_TBGAP0
        ButtonGaps(1) = S_TBGAP1
        cTB = S_TBCOUNT

        iBmpOffset = S_TB_BMPOFFSET
    Else
        '
        ' init the unsubmitted toolbar messages and tips
        '
        cGaps = US_TBGAPCOUNT
        ReDim ButtonGaps(cGaps) As Integer
        ButtonGaps(0) = US_TBGAP0
        ButtonGaps(1) = US_TBGAP1
        ButtonGaps(2) = US_TBGAP2
        ButtonGaps(3) = US_TBGAP3
        cTB = US_TBCOUNT
        If frm.fFormSend Then
            iBmpOffset = US_BIGSENDOFFSET
        Else
            iBmpOffset = US_BIGPOSTOFFSET
        End If
        
        frm.BigButton.PictureUp = LoadResPicture(iBmpOffset, 0)
        frm.BigButton.PictureDn = LoadResPicture(iBmpOffset + 1, 0)
        
        iBmpOffset = US_TB_BMPOFFSET
    End If
    '
    ' init the toolbar
    '
    frm.InitTBStrings
    '
    ' set up the panel
    '
    frm.pnlToolbar.height = frm.grpToolBar(0).height + (TB_HEIGHTEXTRA * Screen.TwipsPerPixelY)
    '
    ' init the starting x position
    '
    xPos = (TB_XSTART * Screen.TwipsPerPixelX)

    For iTB = 0 To (cTB - 1)
        '
        ' loop for all toolbar buttons
        '
        frm.grpToolBar(iTB).top = TB_YSTART * Screen.TwipsPerPixelY
        frm.grpToolBar(iTB).left = xPos
        '
        ' adjust the x position one button width minus one pixel (so the vertical borders overlap)
        '
        xPos = xPos + frm.grpToolBar(iTB).width
        '
        ' add a gap at the appropriate spots
        '
        For iGaps = 0 To (cGaps - 1)
            If iTB = ButtonGaps(iGaps) Then
                xPos = xPos + (TB_GAPWIDTH * Screen.TwipsPerPixelX)
            End If
        Next iGaps
        '
        ' now do the toolbar buttons
        '
        frm.grpToolBar(iTB).PictureUp = LoadResPicture((iTB + iBmpOffset), 0)
        frm.grpToolBar(iTB).Visible = True
    Next iTB
End Sub

Sub HandleTT()
'
' This routine determines which ToolTip should be displayed and then call
' VDisplayTT to display it.
'
' This routine is normally called by the Timer in the frmMnu after the user
' moves the mouse over a control that is tied to a ToolTip
'
    Dim ctlCur As Control
    Static ctlPrev As Control
    Dim ptCursor As POINTAPI
    Dim ictl As Integer
    Dim ctl As Control
    '
    ' Initialize point structure:
    '
    On Error GoTo ToolTipErr
    
    GetCursorPos ptCursor
    Dim rc As RECT, Control As Control

    ' Now get the control containing the cursor
    Set ctlCur = Nothing
    
    With ptCursor
    For Each Control In gTTCallingForm.Controls
        If (Control.Name = gTTControl.Name) Then
            Call GetWindowRect(Control.hWnd, rc)
            If (.x >= rc.left) And (.x <= rc.right) And _
               (.y >= rc.top) And (.y <= rc.bottom) Then
                Set ctlCur = Control
                Exit For
            End If
        End If
    Next
    End With

    '
    ' Same as last window? If so, don't need to redraw:
    '
    If (ctlCur Is Nothing) Then
        '
        ' turn off tooltips
        '
        Call DisplayTT("")
        Call StopTT
        Set ctlPrev = Nothing
        Call SetStatusMessage(gTTCallingForm, 0)

    Else
        
        If (Not (ctlCur Is ctlPrev)) Or (ctlPrev Is Nothing) Then
            '
            ' Store the current ctl and hWnd:
            '
            Set ctlPrev = ctlCur
            '
            ' Decrease timer interval to 1 ms:
            '
            frmTT!Tim.Interval = tmsMin
            '
            ' Handle displaying the tooltip
            '
            Call DisplayTT(gTTCallingForm.GetTT(ctlCur.Index))
            Call SetStatusMessage(gTTCallingForm, gTTCallingForm.GetSS(ctlCur.Index))
        End If
    End If
    
    Exit Sub
    
ToolTipErr:

    Exit Sub
    
End Sub


Sub DisplayTT(stTT As String)
'
' This routine displays a tool tip.
' It senses VB Control IDs as well as hwnds
'
    Dim ptCursor As POINTAPI     ' Cursor Point variable
    Dim ret As Integer      ' Return value of ShowWindow() API function
    '
    ' Display Help String
    '
    ' This Function displays the stTT if stTT <> "".
    ' if stTT = "" then the Help String is removed.
    '
    ' FUNCTION REQUIREMENTS:
    '     GetCursorPos()    Windows API function
    '     frmTT           Name of the Help form
    '
    On Error GoTo DispTTErr
    
    If Len(stTT) <> 0 Then
        '
        ' Show the ToolTip
        '
        ' Make sure help form is invisible:
        '
        frmTT.Hide
        '
        ' Change caption of label:
        '
        frmTT!lbl.Caption = stTT
    
        ' Get the cursor position so you can calculate where to place the
        ' help form:
        Call GetCursorPos(ptCursor)
    
        ' Offset the form from the cursor by 18 and 2 pixels
        frmTT.top = (ptCursor.y + 18) * vtppY
        frmTT.left = (ptCursor.x - 2) * vtppY
    
        ' Adjust width of form to label + 4  because 2 are needed for each
        ' pixel of the border and 2 are needed to center the label (the
        ' label is inset by 1 pixel on the form). Also, adjust height of
        ' form to height of label + 2 because 2 ar needed for each pixel
        ' of the border:
        frmTT.width = (frmTT!lbl.width + 4) * vtppX
        frmTT.height = (frmTT!lbl.height + 2) * vtppY
    
        ' Make sure form is on top:
        frmTT.ZOrder
    
        ' Show form without the focus:
        ret = ShowWindow(frmTT.hWnd, SW_SHOWNA)
    Else
        ' Hide the form:
        frmTT.Hide
    
    End If
    Exit Sub
    
DispTTErr:

    Exit Sub
    
End Sub


Sub StartTT()
'
' This routine prepares things to show a tooltip.
'
    On Error Resume Next
    
    If fTT Then
        frmTT!Tim.Enabled = True
    End If
End Sub


Sub StopTT()
'
' This routine simply turns off a ToolTip
'
    On Error GoTo StopTTErr
    
    frmTT!Tim.Interval = tmsONESEC
    frmTT!Tim.Enabled = False
    frmTT.Hide

    Exit Sub
    
StopTTErr:
    Exit Sub
    
End Sub


Sub SetStatusMessage(frm As Form, ByVal ResID As Long)
    On Error Resume Next  'if LoadResData fails (no message for current field) then make the status bar blank
    Dim strNewStatMsg As String
    strNewStatMsg = " "
    If ResID <> 0 Then
         strNewStatMsg = CStr(LoadResData(ResID, (ResType + ResType_ST)))
    End If
    If frm.pnlStatusBar.Caption <> strNewStatMsg Then
        frm.pnlStatusBar.Caption = strNewStatMsg
    End If
End Sub

Sub SetControlStatusMessage(frm As Form)
    Dim ctlCurrent, strNewStatMsg As String
    strNewStatMsg = " "
    On Error Resume Next
    Set ctlCurrent = frm.ActiveControl
    MakeSureImVisible frm, ctlCurrent
    Do Until ctlCurrent Is Nothing
        strNewStatMsg = CStr(LoadResData(CLng(ctlCurrent.Tag), (ResType + ResType_ST)))
        If strNewStatMsg <> " " Then Exit Do
        Set ctlCurrent = CtrlParent(frm, ctlCurrent)
    Loop
    If frm.pnlStatusBar.Caption <> strNewStatMsg Then
        frm.pnlStatusBar.Caption = strNewStatMsg
    End If
End Sub

Public Sub MakeSureImVisible(frm As Form, ctl)
  Dim ctlTyped As Control, fResizeV As Boolean, fResizeH As Boolean, ctlParent As Control
  ' Ctl=Control, Vis=Visible area
  Dim rCtl As RECT, rVis As RECT ' all in pixels relative to canvas
  Dim dyStatusBar As Integer, dyHScroll As Integer, dxVScroll As Integer
  Dim yTwipsPer As Integer, xTwipsPer As Integer
  yTwipsPer = Screen.TwipsPerPixelY
  xTwipsPer = Screen.TwipsPerPixelX
  Set ctlTyped = ctl
  Set ctlParent = CtrlParent(frm, ctl)
  On Error Resume Next
  If Not (frm.EnvFrame Is ctlParent) Then
    'If the parent is not an envelope ctl OR if we just don't have the EnvFrame
  Else
    Exit Sub 'Ignore stuff on the envelope header
  End If
  If TabPage(frm, ctlTyped, True) > -1 And (Not ctlTyped Is frm.ActiveControl) Then
    SetFocusTo ctlTyped
  End If
  
  With frm
    If .pnlStatusBar.Visible Then dyStatusBar = .pnlStatusBar.height
    If .vsbCanvas.Visible Then dxVScroll = .vsbCanvas.width
    If .hsbCanvas.Visible Then dyHScroll = .hsbCanvas.height
    
    rCtl.top = -30 / yTwipsPer
    rCtl.left = -30 / xTwipsPer
    
    rCtl.bottom = IIf(ctl Is frm.rtfStretch, 360, (ctl.height + 90)) / yTwipsPer
    rCtl.right = IIf(ctl Is frm.rtfStretch, 1440, (ctl.width + 90)) / xTwipsPer
    
    ' Convert to pixels after we use them next
    rVis.top = -.Canvas_Ctrl.top
    rVis.left = -.Canvas_Ctrl.left
    
    rVis.bottom = (.ScaleHeight + rVis.top - dyHScroll - dyStatusBar - .CanvasParent.top) / yTwipsPer
    rVis.right = (.ScaleWidth + rVis.left - dxVScroll) / xTwipsPer
    
    rVis.top = rVis.top / yTwipsPer
    rVis.left = rVis.left / xTwipsPer
    
    MapWindowPoints ctl.hWnd, .Canvas_Ctrl.hWnd, rCtl, 2
    
    If rCtl.top < rVis.top Then
      ' Control is too high--scroll up
      rVis.top = IIf(rCtl.top > 0, rCtl.top, 0)
      fResizeV = True
    ElseIf rCtl.bottom > rVis.bottom Then
      ' Control is too low--scroll down
      Dim yNewTop As Integer
      yNewTop = rVis.top + rCtl.bottom - rVis.bottom
      rVis.top = IIf(yNewTop > rCtl.top, rCtl.top, yNewTop)
      fResizeV = True
    End If
    
    If rCtl.left < rVis.left Then
      ' Control is too far left--scroll left
      rVis.left = IIf(rCtl.left > 0, rCtl.left, 0)
      fResizeH = True
    ElseIf rCtl.right > rVis.right Then
      ' Control is too far right--scroll right
      Dim xNewLeft As Integer
      xNewLeft = rVis.left + rCtl.right - rVis.right
      rVis.left = IIf(xNewLeft > rCtl.left, rCtl.left, xNewLeft)
      fResizeH = True
    End If
    
    If fResizeV Then
    
      	If rVis.top * yTwipsPer > .vsbCanvas.Max And .vsbCanvas.Max > 0 Then 
      		rVis.top = Fix(.vsbCanvas.Max / yTwipsPer) ' round smaller
      	End If
      	
	  	.Canvas_Ctrl.top = -rVis.top * yTwipsPer
	  	.vsbCanvas = -.Canvas_Ctrl.top
    End If
    If fResizeH Then
    
      	If rVis.left * xTwipsPer > .hsbCanvas.Max And .hsbCanvas.Max > 0 Then 
      		rVis.left = Fix(.hsbCanvas.Max / xTwipsPer) ' round smaller
      	End If
      	
        .Canvas_Ctrl.left = -rVis.left * xTwipsPer
      	.hsbCanvas = -.Canvas_Ctrl.left
    End If
  End With
End Sub


