// ExRaidoc.h : interface of the CExRaidDoc class
//
/////////////////////////////////////////////////////////////////////////////

#define cbTimestamp 8
#define idSyncTimer 1

typedef struct _COLUMNHEADERS {
    char * pszName;
    ULONG  ulType;
} COLHEADERS, * PCOLHEADERS;

typedef enum SYNCTIME {
	stHours,
	stMinutes
};

class CExRaidDoc : public CDocument
{
protected: // create from serialization only
	CExRaidDoc();
	DECLARE_DYNCREATE(CExRaidDoc)

// Attributes
protected:
    CString m_szDatabase;
    CString m_szPassword;
    CString m_szUserID;
    CString m_szProfileName;
    CString m_szFolderName;
    CString m_szMessageClass;
    CString m_szOutputFile;
    UINT    m_cSyncTime; 
	INT		m_stUnits;
    CByteArray m_cbaMaxTimestamp;
public:
	CExRaidSet m_exRaidSet;
	CString m_szLastUpdated;
	CString m_szTimeToUpdate;
    CString m_szBugsPerSec;
	CString m_szError;
	BOOL    m_fRunning;
	ULONG   m_cBugsUpdated;
	ULONG   m_cBugsCreated;
	ULONG   m_cBugsRead;
	ULONG   m_cSeconds;

// Operations
public:
	void OnSyncronize(BOOL fSyncAll);
	void SyncronizeRunning(BOOL fStartUp);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CExRaidDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CExRaidDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	
protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CExRaidDoc)
	afx_msg void OnOptionsRaiddatabase();
	afx_msg void OnOptionsPublicfolder();
	afx_msg void OnSyncronizeNow();
	afx_msg void OnSyncronizeAll();
	afx_msg void OnSyncronizeRunning();
	afx_msg void OnUpdateSyncronizeRunning(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

// Helper Functions

BOOL FTimeTToFileTime(time_t tt, FILETIME * pft);


