// ExRaiset.cpp : implementation of the CExRaidSet class
//

#include "stdafx.h"
#include "ExRaid.h"
#include "ExRaiset.h"

/////////////////////////////////////////////////////////////////////////////
// CExRaidSet implementation

IMPLEMENT_DYNAMIC(CExRaidSet, CRecordset)

CExRaidSet::CExRaidSet(CDatabase* pdb)
	: CRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CExRaidSet)
	m_Description = "";
	m_BugID = 0;
	m_LinkCount = 0;
	m_Rev = 0;
	m_Title = "";
	m_Status = "";
	m_AssignedTo = "";
	m_ActiveDB = "";
	m_IssueType = "";
	m_Severity = "";
	m_Priority = "";
	m_ChangedBy = "";
	m_Environment = "";
	m_OpenedBy = "";
	m_OpenedRev = "";
	m_Source = "";
	m_SourceID = "";
	m_Lang = "";
	m_ResolvedBy = "";
	m_Resolution = "";
	m_FixedRev = "";
	m_CodeChange = "";
	m_ClosedBy = "";
	m_KBArticle = "";
	m_howfound = "";
	m_Cause = "";
	m_nFields = 31;
	//}}AFX_FIELD_INIT

	m_szDefaultConnect = "";
}

CString CExRaidSet::GetDefaultConnect()
{
	return m_szDefaultConnect;
}

CString CExRaidSet::GetDefaultSQL()
{
	return _T("dbo.Bugs");
}

void CExRaidSet::DoFieldExchange(CFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CExRaidSet)
	pFX->SetFieldType(CFieldExchange::outputColumn);
	RFX_Text(pFX, "Description", m_Description, 16384);
	RFX_Long(pFX, "BugID", m_BugID);
	RFX_Binary(pFX, "timestamp", m_timestamp);
	RFX_Int(pFX, "LinkCount", m_LinkCount);
	RFX_Long(pFX, "Rev", m_Rev);
	RFX_Text(pFX, "Title", m_Title);
	RFX_Text(pFX, "Status", m_Status);
	RFX_Text(pFX, "AssignedTo", m_AssignedTo);
	RFX_Text(pFX, "ActiveDB", m_ActiveDB);
	RFX_Text(pFX, "IssueType", m_IssueType);
	RFX_Text(pFX, "Severity", m_Severity);
	RFX_Text(pFX, "Priority", m_Priority);
	RFX_Date(pFX, "ChangedDate", m_ChangedDate);
	RFX_Text(pFX, "ChangedBy", m_ChangedBy);
	RFX_Text(pFX, "Environment", m_Environment);
	RFX_Date(pFX, "OpenedDate", m_OpenedDate);
	RFX_Text(pFX, "OpenedBy", m_OpenedBy);
	RFX_Text(pFX, "OpenedRev", m_OpenedRev);
	RFX_Text(pFX, "Source", m_Source);
	RFX_Text(pFX, "SourceID", m_SourceID);
	RFX_Text(pFX, "Lang", m_Lang);
	RFX_Date(pFX, "ResolvedDate", m_ResolvedDate);
	RFX_Text(pFX, "ResolvedBy", m_ResolvedBy);
	RFX_Text(pFX, "Resolution", m_Resolution);
	RFX_Text(pFX, "FixedRev", m_FixedRev);
	RFX_Text(pFX, "CodeChange", m_CodeChange);
	RFX_Date(pFX, "ClosedDate", m_ClosedDate);
	RFX_Text(pFX, "ClosedBy", m_ClosedBy);
	RFX_Text(pFX, "KBArticle", m_KBArticle);
	RFX_Text(pFX, "howfound", m_howfound);
	RFX_Text(pFX, "Cause", m_Cause);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CExRaidSet diagnostics

#ifdef _DEBUG
void CExRaidSet::AssertValid() const
{
	CRecordset::AssertValid();
}

void CExRaidSet::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG



BOOL CExRaidSet::Open(UINT nOpenType, LPCTSTR lpszSql, DWORD dwOptions) 
{
	// Opening the Database with no Cursor support to try and avoid tmp file
	// creation.  Without this, I need approx 550MB of free disk space
	// to import the Exchange Raid Database.
	// Currently, I need a forwardOnly and readOnly access to the database
	// to make this happen.  This will need to change if I need write
	// access.

	CString strDefaultConnect;

	TRY
	{
		if (m_pDatabase == NULL)
		{
			m_pDatabase = new CDatabase();
			m_bRecordsetDb = TRUE;
		}

		strDefaultConnect = GetDefaultConnect();
		// If not already opened, attempt to open
		if (!m_pDatabase->IsOpen() &&
			!m_pDatabase->Open(&afxChNil, FALSE, FALSE, strDefaultConnect, FALSE))
			return FALSE;
	}
	CATCH_ALL(e)
	{
#ifdef _DEBUG
		if (afxTraceFlags & traceDatabase)
			TRACE0("Error: CDatabase create for CRecordset failed.\n");
#endif
		if (m_bRecordsetDb)
		{
			delete m_pDatabase;
			m_pDatabase = NULL;
		}
		ASSERT(m_hstmt == SQL_NULL_HSTMT);
		THROW_LAST();
	}
	END_CATCH_ALL

	return CRecordset::Open(forwardOnly, lpszSql, readOnly);
}
