// ExRaivw.cpp : implementation of the CExRaidView class
//

#include "stdafx.h"
#include "ExRaid.h"

#include "ExRaiset.h"
#include "ExRaidoc.h"
#include "ExRaivw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExRaidView

IMPLEMENT_DYNCREATE(CExRaidView, CRecordView)

BEGIN_MESSAGE_MAP(CExRaidView, CRecordView)
	//{{AFX_MSG_MAP(CExRaidView)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CRecordView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRecordView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExRaidView construction/destruction

CExRaidView::CExRaidView()
	: CRecordView(CExRaidView::IDD)
{
	//{{AFX_DATA_INIT(CExRaidView)
	m_pSet = NULL;
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CExRaidView::~CExRaidView()
{
}

void CExRaidView::DoDataExchange(CDataExchange* pDX)
{
	CRecordView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExRaidView)
	//}}AFX_DATA_MAP
}

void CExRaidView::OnInitialUpdate()
{
	CExRaidDoc * pExRaidDoc = NULL;
	CWinApp * pApp = AfxGetApp();
    CWnd *    pMainWnd = NULL;
	WINDOWPLACEMENT wp;
	CString   szSection;
	CString   szEntry;
	CString   szError;
	BOOL      fRet;
	
	// Set Saved Window Position

	szSection.LoadString(IDS_SECTION_SETTINGS);
	szEntry.LoadString(IDS_REG_LEFT);
	wp.rcNormalPosition.left = pApp->GetProfileInt(szSection, szEntry, 0);
	szEntry.LoadString(IDS_REG_TOP);
	wp.rcNormalPosition.top = pApp->GetProfileInt(szSection, szEntry, 0);
	szEntry.LoadString(IDS_REG_RIGHT);
	wp.rcNormalPosition.right = pApp->GetProfileInt(szSection, szEntry, 0);
	szEntry.LoadString(IDS_REG_BOTTOM);
	wp.rcNormalPosition.bottom = pApp->GetProfileInt(szSection, szEntry, 0);

	if (wp.rcNormalPosition.left  || wp.rcNormalPosition.top || 
	    wp.rcNormalPosition.right || wp.rcNormalPosition.bottom)
	{
		wp.length = sizeof(WINDOWPLACEMENT);
		wp.flags = 0;
		wp.showCmd = SW_RESTORE;
		wp.ptMinPosition.x = 0;
		wp.ptMinPosition.y = 0;
		wp.ptMaxPosition.x = 0;
		wp.ptMaxPosition.y = 0;
		ASSERT(pApp);
		pMainWnd = pApp->GetMainWnd();
		ASSERT(pMainWnd);
		fRet = pMainWnd->SetWindowPlacement(&wp);
		if (!fRet)
		{
			szError.LoadString(IDS_ERROR_SETWINDOWPLACEMENT);
	        AfxMessageBox(szError, MB_ICONEXCLAMATION);
		}
	}

	m_pSet = &GetDocument()->m_exRaidSet;

	// Start Syncronization if running when last exited.

	pExRaidDoc = GetDocument();
	ASSERT(pExRaidDoc);
	if (pExRaidDoc->m_fRunning)
	{
		pExRaidDoc->SyncronizeRunning(TRUE);
	}

	CRecordView::OnInitialUpdate();

}

/////////////////////////////////////////////////////////////////////////////
// CExRaidView printing

BOOL CExRaidView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CExRaidView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CExRaidView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CExRaidView diagnostics

#ifdef _DEBUG
void CExRaidView::AssertValid() const
{
	CRecordView::AssertValid();
}

void CExRaidView::Dump(CDumpContext& dc) const
{
	CRecordView::Dump(dc);
}

CExRaidDoc* CExRaidView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CExRaidDoc)));
	return (CExRaidDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CExRaidView database support

CRecordset* CExRaidView::OnGetRecordset()
{
	return m_pSet;
}


/////////////////////////////////////////////////////////////////////////////
// CExRaidView message handlers

void CExRaidView::OnTimer(UINT nIDEvent) 
{
	CExRaidDoc * pCExRaidDoc = NULL;
	
	// Get pointer to document, then call OnSyncronizeNow(FALSE);
	
	pCExRaidDoc = GetDocument();
	ASSERT(pCExRaidDoc);
	
	switch (nIDEvent)
	{
		case idSyncTimer:
			pCExRaidDoc->OnSyncronize(FALSE);
			break;
		default:
			break;
	}

	CRecordView::OnTimer(nIDEvent);
}



void CExRaidView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
    CExRaidDoc * pCExRaidDoc;
	CButton * pCButton;
	CString   szBugsPerSec;
    
    switch (lHint)
    {
        case IDC_LASTUPDATED:
			pCExRaidDoc = (CExRaidDoc *)pHint;

			SetDlgItemInt(IDC_BUGSCREATED, pCExRaidDoc->m_cBugsCreated, FALSE);
			SetDlgItemInt(IDC_BUGSUPDATED, pCExRaidDoc->m_cBugsUpdated, FALSE);
			SetDlgItemInt(IDC_BUGSREAD, pCExRaidDoc->m_cBugsRead, FALSE);

			SetDlgItemText(IDC_BUGSPERSEC, pCExRaidDoc->m_szBugsPerSec);
    		
			SetDlgItemText(IDC_TIMETOUPDATE, pCExRaidDoc->m_szTimeToUpdate);
			SetDlgItemText(IDC_STATUS, pCExRaidDoc->m_szError);
			SetDlgItemText(lHint, pCExRaidDoc->m_szLastUpdated);

            break;
		case IDC_SYNCRUNNING:
			pCExRaidDoc = (CExRaidDoc *)pHint;

			pCButton = (CButton *) GetDlgItem(lHint);
			ASSERT(pCButton);
			pCButton->SetCheck(pCExRaidDoc->m_fRunning);
			break;
        default:
            CRecordView::OnUpdate(NULL, 0, NULL);
            break;
    }	
}
