/*
**************************************************************************
	SQLDEMO						Stewart MacLeod					2/22/96

	Manifest Constant Definitions
**************************************************************************
*/	
#define SQL_APP_NAME			"SQL Server User Simulator"
#define SQL_APP_ERROR			"Error: SQL Server User Simulator"
#define DEFAULT_DATABASE		"PUBS"
#define DEFAULT_USERS			"10"
#define MAX_USERS				15
#define SQL_SUCCESS				0
#define SQL_FAILURE				1
#define SQL_MAX_THREADS			1024
#define SQL_LOGIN_TIMEOUT		30
#define SQL_QUERY_TIMEOUT		100
#define MAX_STRING_SIZE			1024
#define MAX_SQL_STRING			1024
#define THREAD_STACK_SIZE		(20*1024)
#define THREAD_COUNT			5

#define IDD_SQLDIALOG			1
#define IDC_EDITSERVER			101
#define IDC_EDITDATABASE		102
#define IDC_EDITUSERS			103
#define IDC_START				104
#define IDC_STOP				105
#define IDC_EXIT				106
#define IDC_STATIC				(-1)

/*
**************************************************************************
	Structure Definitions
**************************************************************************
*/	

struct THREADINFO {
	unsigned long hThread;
	unsigned int dwThreadId;
	DWORD dwThreadParam;
};

/*
**************************************************************************
	Function Prototypes
**************************************************************************
*/					   

int SQLAPI ErrorHandler(DBPROCESS *lpDbProc, int iSeverity,int iDbError, int iOsError, const char *lpszDbErrorMsg, const char *lpszOsErrorMsg);
int SQLAPI MessageHandler(DBPROCESS *lpDbProc, DBINT iMsgNumber, int iMsgState, int iSeverity, const char *lpszMessageText, const char *szServerName, const char *szProcName, unsigned short iLineNumber);
DWORD WINAPI CreateUser( LPVOID lpv );
BOOL ProcessSql( DBPROCESS *dbproc, char * SqlStatement );
BOOL CALLBACK Dlg_Proc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam );
void GetFirstName( char * lpszFirstName );
void GetAppName( char * lpszAppName );
void GetHostName( char * lpszHostName );
void GetSqlStatement( char * lpszSqlStatement );	
BOOL GetMachineName(char *lpszMachine);



