use pubs
go
/*
********************************************************************
	Case Statement SELECT Example
********************************************************************
*/

SELECT 	"Price Category" = 
		CASE 
			WHEN price IS NULL THEN 'Not yet priced'
			WHEN price < 10 THEN 'Very Reasonable Title'
			WHEN price >= 10 and price < 20 THEN 'Coffee Table Title'
			ELSE 'Expensive book!'
		END,
	"Shortended Title" = CONVERT(varchar(20), title),
	Category = 
		CASE type
			WHEN 'popular_comp' THEN 'Popular Computing'
			WHEN 'mod_cook' THEN 'Modern Cooking'
			WHEN 'business' THEN 'Business'
			WHEN 'psychology' THEN 'Psychology'
			WHEN 'trad_cook' THEN 'Traditional Cooking'
			ELSE 'Not yet categorized'
		END
FROM titles
ORDER BY price
go

/*
********************************************************************
	Case Statement SUBQUERY Example
********************************************************************
*/

SELECT "Author's Full Name" = CONVERT(varchar(25), (RTRIM(au_fname) +
							 ' ' + RTRIM(au_lname))),
	"Shortened Title" = CONVERT(varchar(25), title),
	"Royalty Category" =
		CASE
			WHEN (SELECT AVG(royaltyper) FROM titleauthor ta
					WHERE t.title_id = ta.title_id) > 60
				THEN 'High Royalty'
			WHEN (SELECT AVG(royaltyper) FROM titleauthor ta
					WHERE t.title_id = ta.title_id)
						BETWEEN 41 and 59
				THEN 'Medium Royalty'
ELSE 'Low Royalty'
		END
FROM authors a, titles t, titleauthor ta
WHERE a.au_id = ta.au_id AND ta.title_id = t.title_id
ORDER BY "Royalty Category", "Author's Full Name"
go

/*
********************************************************************
	Case Statement UPDATE Example
********************************************************************
*/


UPDATE employee_salaries
	SET salary =
		CASE 
			WHEN (review = 4 AND 
				(DATEDIFF(month, hire_date, GETDATE()) > 18)) 
				THEN salary * 2
			WHEN (review = 3 AND 
				(DATEDIFF(month, hire_date, GETDATE()) > 18)) 
				THEN salary * 1.6
			WHEN (review = 2 AND 
				(DATEDIFF(month, hire_date, GETDATE()) > 18)) 
				THEN salary * 1.2
			ELSE salary
		END
go