use pubs
go

/*
*****************************************************
  Graphical Showplan
*****************************************************
*/

select au_lname, title 
from authors a, titleauthor ta, titles t
where a.au_id = ta.au_id
and t.title_id = ta.title_id
and a.state = 'CA'
order by au_lname
go

/*
*****************************************************
  Using Optimizer Hints in SQL Server 6.0 and 6.5
*****************************************************
*/

select au_lname, title 
from 	authors a (index = aunmind), 
	titleauthor ta (index=titleidind), 
	titles t
where a.au_id = ta.au_id
and t.title_id = ta.title_id
and a.state = 'CA'
order by au_lname
go
