/*
*************************************************************
Stewart MacLeod			SQL Server 6.X		DRI

Debit Savings Credit Checking transaction simple case
	
	* no referential integrity
	* no error handling
	* no stored procedures

*************************************************************
*/


/*
*********************************************************************
	Drop the example tables if they exist
*********************************************************************
*/

if exists (select * from sysobjects where name = 'savings' and type = 'U')
begin
	drop table savings
end
go

if exists (select * from sysobjects where name = 'checking' and type = 'U')
begin
	drop table checking
end
go


if exists (select * from sysobjects where name = 'customer' and type = 'U')
begin
	drop table customer
end
go


/*
*********************************************************************
	Create the customer table
*********************************************************************
*/

create table customer
(
	custid	integer not null identity( 1,1),
	name	character(30) not null,
	phone	character(14) not null
	
)
go

/*
*********************************************************************
	Add some sample data
*********************************************************************
*/

insert into customer(name,phone) values ('stewart','(206) 936-7374')
insert into customer(name,phone) values ('deby','(206) 936-4616')
insert into customer(name,phone) values ('gary','(206) 936-3615')
insert into customer(name,phone) values ('ron','(206) 936-4433')
insert into customer(name,phone) values ('jane','(206) 936-4216')
insert into customer(name,phone) values ('fred','(206) 936-1215')
go

/*
*********************************************************************
	Create the savings table
*********************************************************************
*/


create table savings
(
	custid	integer not null,
	balance	decimal(10,2) not null	
)
go

/*
*********************************************************************
	Add some sample data
*********************************************************************
*/

insert into savings(custid,balance) values (1, 1000.00)
insert into savings(custid,balance) values (2, 2000.00)
insert into savings(custid,balance) values (3, 3000.00)
insert into savings(custid,balance) values (4, 4000.00)
insert into savings(custid,balance) values (5, 5000.00)
insert into savings(custid,balance) values (6, 6000.00)
go

/*
*********************************************************************
	Create the checking table
*********************************************************************
*/

create table checking
(
	custid	integer not null,
	balance	decimal(10,2) not null	
)
go

/*
*********************************************************************
	Add some sample data
*********************************************************************
*/

insert into checking(custid,balance) values (1, 1000.00)
insert into checking(custid,balance) values (2, 2000.00)
insert into checking(custid,balance) values (3, 3000.00)
insert into checking(custid,balance) values (4, 4000.00)
insert into checking(custid,balance) values (5, 5000.00)
insert into checking(custid,balance) values (6, 6000.00)
go

/*
*********************************************************************
	Define and execute a transaction
*********************************************************************
*/

begin transaction

	update savings set balance = balance - 100 where custid = 1
	update checking set balance = balance + 100 where custid = 1

commit transaction

go

/*
***************************************************************
drop all the tables
***************************************************************
*/

if exists (select * from sysobjects where name = 'savings' and type = 'U')
begin
	drop table savings
end
go

if exists (select * from sysobjects where name = 'checking' and type = 'U')
begin
	drop table checking
end
go


if exists (select * from sysobjects where name = 'customer' and type = 'U')
begin
	drop table customer
end
go


